define GRPPCT (nrep = !charend('/')/
               within = !charend('/') /
               grp = !charend('/') /
               wgt = !charend('/') /
               rwgt = !charend('/') /
               cons = !charend('/')/
               infile = !charend('/')).



get file !infile /keep !within !grp !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep)).
sort cases by !grp.
save outfile='c:\temp\sort.sav'.



*** COMPUTE ESTIMATE ***.

weight by !wgt.
aggregate outfile='c:\temp\temp1.sav' /break=!within /N_all=n.
aggregate outfile=* /break=!within !grp /N_grp=n.
exe.
match files file=* /table='c:\temp\temp1.sav' /by !within.
compute stat=100*(n_grp/n_all).  
save outfile=!quote(!concat('c:\temp\',!grp,'.sav')). 

* REPLICATES.   

!do !i= 1 !to !nrep.
get file 'c:\temp\sort.sav'.
weight by !concat(!rwgt,!i).
aggregate outfile='c:\temp\temp2.sav' /break=!within /N_all=n.
aggregate outfile=* /break=!within !grp /N_grp=n.
exe.
match files file=* /table='c:\temp\temp2.sav' /by !within.
compute statR=100*(n_grp/n_all).
save outfile=!quote(!concat('c:\temp\',!grp,'_',!i,'.sav')).
erase file='c:\temp\temp2.sav'.
!doend.



*** COMBINE RESULTS ***.

get file =!quote(!concat('c:\temp\',!grp,'_1.sav')).

!Do !e = 2 !to !nrep.
add files file=* /file=!quote(!concat('c:\temp\',!grp,'_',!e,'.sav')).
!Doend.

sort cases by !within !grp.

match files file=* /table=!quote(!concat('c:\temp\',!grp,'.sav')) /by !within !grp.
exec.




*** COMPUTE SAMPLING VARIANCE (U) ***.

compute var=(statr-stat)**2.
exec.

save outfile = 'c:\temp\regmod.sav'.

aggregate outfile=*/
	  break=!within !grp/ 
          stat= mean(stat)/
          var=sum(var).

compute var=!cons*var.




*** COMPUTE STANDARD ERROR ***.

compute SE=sqrt(var).
exec.

formats stat (f8.3)/ SE (f10.6).
list cases/var= !within !grp stat SE.

!enddefine.





