define PCTLEV (nrep = !charend('/')/
               within = !charend('/') /
               grp = !charend('/') /
               wgt = !charend('/') /
               rwgt = !charend('/') /
               cons = !charend('/')/
               infile = !charend('/')).



*** COMPUTE ESTIMATE ***.

get file !infile /keep !within !concat(!grp,'1') !concat(!grp,'2') !concat(!grp,'3') !concat(!grp,'4')
   !concat(!grp,'5') !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep)).
weight by !wgt.
aggregate outfile='c:\temp\temp10.sav' /break=!within /N_all=n.

!do !j=1 !to 5.
get file !infile /keep !within !concat(!grp,'1') !concat(!grp,'2') !concat(!grp,'3') !concat(!grp,'4')
   !concat(!grp,'5') !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep)).
weight by !wgt.
aggregate outfile=* /break=!within !concat(!grp,!j) /N_grp=n.
exe.
match files file=* /table='c:\temp\temp10.sav' /by !within.
compute !concat('stat',!j)=100*(n_grp/n_all).  
rename var (!concat(!grp,!j)=!grp).
save outfile=!quote(!concat('c:\temp\temp',!j,'.sav')) /keep=!within !grp !concat('stat',!j). 
!doend.

match files file='c:\temp\temp1.sav'
           /file='c:\temp\temp2.sav'
           /file='c:\temp\temp3.sav'
           /file='c:\temp\temp4.sav'
           /file='c:\temp\temp5.sav'
           /by !within !grp.
save outfile='c:\temp\all.sav'.           

* REPLICATES.   

!do !i= 1 !to !nrep.
get file !infile /keep !within !concat(!grp,'1') !concat(!grp,'2') !concat(!grp,'3') !concat(!grp,'4')
   !concat(!grp,'5') !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep)).
weight by !concat(!rwgt,!i).
erase file='c:\temp\temp20.sav'.
aggregate outfile='c:\temp\temp20.sav' /break=!within /N_all=n.

!do !j=1 !to 5.
get file !infile /keep !within !concat(!grp,'1') !concat(!grp,'2') !concat(!grp,'3') !concat(!grp,'4')
   !concat(!grp,'5') !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep)).
weight by !concat(!rwgt,!i).

aggregate outfile=* /break=!within !concat(!grp,!j) /N_grp=n.
exe.
match files file=* /table='c:\temp\temp20.sav' /by !within.
compute !concat('statR',!j)=100*(n_grp/n_all).  
rename var (!concat(!grp,!j)=!grp).
save outfile=!quote(!concat('c:\temp\temp',!j,'.sav')) /keep=!within !grp !concat('statR',!j). 
!doend.

match files file='c:\temp\temp1.sav'
           /file='c:\temp\temp2.sav'
           /file='c:\temp\temp3.sav'
           /file='c:\temp\temp4.sav'
           /file='c:\temp\temp5.sav'
           /by !within !grp.
save outfile=!quote(!concat('c:\temp\',!grp,'_',!i,'.sav')).
!doend.



*** COMBINE RESULTS ***.

get file =!quote(!concat('c:\temp\',!grp,'_1.sav')).

!Do !e = 2 !to !nrep.
add files file=* /file=!quote(!concat('c:\temp\',!grp,'_',!e,'.sav')).
!Doend.

sort cases by !within !grp.

match files file=* /table='c:\temp\all.sav' /by !within !grp.
exec.




*** COMPUTE SAMPLING VARIANCE (U) ***.

do repeat a=statr1 to statr5/
	  b=stat1 to stat5/
	  c=var1 to var5.
compute c=(a-b)**2.
end repeat.
save outfile = 'c:\temp\regmod.sav'.

aggregate outfile=*/
	  break=!within !grp/ 
          stat1 to stat5= mean(stat1 to stat5)/
          var1 to var5 = sum(var1 to var5).

do repeat a=var1 to var5.
compute a=!cons*a.
end repeat.

compute pv_var=mean(var1 to var5).




*** CALCULATING MEASUREMENT VARIANCE (Bm) ***.

compute stat=mean(stat1 to stat5).

do repeat a=stat1 to stat5/b=pvar1 to pvar5.
compute b=(a-stat)**2.
end repeat.

compute pvmerr=.25*(sum(pvar1 to pvar5)).




*** COMPUTE STANDARD ERROR [V = U + (1+1/M)Bm] ***.

compute SE=sqrt(pv_var+1.2*pvmerr).

formats stat (f8.3)/ SE (f10.6).
list cases/var= !within !grp stat SE.

!enddefine.